#include <stdio.h>
#include <stdlib.h>

struct node {
   int data;
   struct node *left_child;
   struct node *right_child;
};
typedef struct node treenode;
typedef treenode *tree_ptr;

tree_ptr createnode (int data);
void preorder (tree_ptr ptr);
void inorder (tree_ptr ptr);
void postorder (tree_ptr ptr);

main()
{
   tree_ptr ptr;

   ptr = createnode (10);
   ptr->left_child = createnode (20);
   ptr->right_child = createnode (30);
   ptr->left_child->left_child = createnode (40);
   ptr->left_child->right_child = createnode (50);
   ptr->right_child->left_child = createnode (60);
   ptr->right_child->right_child = createnode (70);

   printf("preorder : ");
   preorder (ptr);
   printf("\ninorder : ");
   inorder (ptr);
   printf("\npostorder : ");
   postorder (ptr);
   printf("\n");
}

tree_ptr createnode (int data)
{
   tree_ptr ptr;
   ptr = (tree_ptr)malloc(sizeof(treenode));
   ptr->data = data;
   ptr->left_child = NULL;
   ptr->right_child = NULL;
   return ptr;
}

void preorder (tree_ptr ptr)
{
   if (ptr) {
      printf("%d ", ptr->data);
      preorder(ptr->left_child);
      preorder(ptr->right_child);
   }
}

void inorder (tree_ptr ptr)
{
   if (ptr) {
      inorder(ptr->left_child);
      printf("%d ", ptr->data);
      inorder(ptr->right_child);
   }
}

void postorder (tree_ptr ptr)
{
   if (ptr) {
      postorder(ptr->left_child);
      postorder(ptr->right_child);
      printf("%d ", ptr->data);
   }
}