#include <stdio.h>
#include <stdlib.h>
#define MAX_VERTICES 7

struct node {
   int data;
   struct node *next;
};
typedef struct node *node_ptr;

struct queue {
   int data;
   struct queue *next;
};
typedef struct queue *queue_ptr;

node_ptr table[MAX_VERTICES];
int visited[MAX_VERTICES];

node_ptr createnode (int data);
void bfs (int vertex);
void addq (queue_ptr *front, queue_ptr *rear, int data);
int deleteq (queue_ptr *front);

main()
{
   table[0] = createnode(1);
   table[0]->next = createnode(2);
   table[0]->next->next = createnode(3);
   table[1] = createnode(0);
   table[1]->next = createnode(4);
   table[2] = createnode(0);
   table[2]->next = createnode(5);
   table[3] = createnode(0);
   table[3]->next = createnode(5);
   table[4] = createnode(1);
   table[4]->next = createnode(6);
   table[4]->next->next = createnode(5);
   table[5] = createnode(2);
   table[5]->next = createnode(3);
   table[5]->next->next = createnode(4);
   table[5]->next->next->next = createnode(6);
   table[6] = createnode(4);
   table[6]->next = createnode(5);

   bfs (0);
   printf("\n");
}

node_ptr createnode (int data)
{
   node_ptr ptr;
   ptr = (node_ptr)malloc(sizeof(struct node));
   ptr->data = data;
   ptr->next = NULL;
   return ptr;
}

void bfs (int vertex)
{
   node_ptr vertex_ptr;
   queue_ptr front, rear;
   front = rear = NULL;
   visited[vertex] = 1;
   printf ("%d ", vertex);
   addq (&front, &rear, vertex);
   while (front) {
      vertex = deleteq (&front);
      for (vertex_ptr=table[vertex]; vertex_ptr; vertex_ptr= vertex_ptr->next)
         if (!visited[vertex_ptr->data]) {
            printf ("%d ", vertex_ptr->data);
            addq (&front, &rear, vertex_ptr->data);
            visited[vertex_ptr->data] = 1;
         }
   }
}

void addq (queue_ptr *front, queue_ptr *rear, int data)
{
   queue_ptr temp;
   temp = (queue_ptr)malloc(sizeof(struct queue));
   temp->data = data;
   temp->next = NULL;
   if (*front)
      (*rear)->next = temp;
   else
      *front = temp;
   *rear = temp;
}

int deleteq (queue_ptr *front)
{
   queue_ptr temp;
   int data;
   temp = *front;
   data = temp->data;
   *front = temp->next;
   free(temp);
   return data;
}
